<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Follow Along Nav</title>
  </head>
  <body>
    <h2>Cool</h2>
    <nav class="top">
      <!-- 호버시 나타나는 박스 -->
      <div class="dropdownBackground">
        <span class="arrow"></span>
      </div>

      <ul class="cool">
        <!-- 보여야할 내용1 -->
        <li>
          <a href="#">About Me</a>
          <div class="dropdown dropdown1">
            <div class="bio">
              <img src="https://logo.clearbit.com/wesbos.com" />
              <p>
                Wes Bos user does love web development. He teaches things like Javascript, CSS and BBQ. Wait BBQ is not
                part of web development. It should be though!
              </p>
            </div>
          </div>
        </li>

        <!-- 보여야할 내용2 -->
        <li>
          <a href="#">Courses</a>
          <ul class="dropdown courses">
            <li>
              <span class="code">RFB</span>
              <a href="https://ReactForBeginners.com">React For Beginners</a>
            </li>
            <li>
              <span class="code">ES6</span>
              <a href="https://ES6.io">ES6 For Everyone</a>
            </li>
            <li>
              <span class="code">STPU</span>
              <a href="https://SublimeTextBook.com">Sublime Text Power User</a>
            </li>
            <li>
              <span class="code">WTF</span>
              <a href="http://Flexbox.io">What The Flexbox?!</a>
            </li>
            <li>
              <span class="code">GRID</span>
              <a href="https://CSSGrid.io">CSS Grid</a>
            </li>
            <li>
              <span class="code">LRX</span>
              <a href="http://LearnRedux.com">Learn Redux</a>
            </li>
            <li>
              <span class="code">CLPU</span>
              <a href="http://CommandLinePowerUser.com">Command Line Power User</a>
            </li>
            <li>
              <span class="code">MMD</span>
              <a href="http://MasteringMarkdown.com">Mastering Markdown</a>
            </li>
          </ul>
        </li>

        <!-- 보여야할 내용3 -->
        <li>
          <a href="#">Other Links</a>
          <ul class="dropdown dropdown3">
            <li><a class="button" href="http://twitter.com/wesbos">Twitter</a></li>
            <li><a class="button" href="http://facebook.com/wesbos.developer">Facebook</a></li>
            <li><a class="button" href="http://wesbos.com">Blog</a></li>
            <li><a class="button" href="http://wesbos.com/courses">Course Catalog</a></li>
          </ul>
        </li>
      </ul>
    </nav>
  </body>
  <style>
    html {
      box-sizing: border-box;
      font-family: "Arial Rounded MT Bold", "Helvetica Rounded", Arial, sans-serif;
    }

    *,
    *:before,
    *:after {
      box-sizing: inherit;
    }

    body {
      margin: 0;
      min-height: 100vh;
      background: linear-gradient(45deg, hsla(340, 100%, 55%, 1) 0%, hsla(340, 100%, 55%, 0) 70%),
        linear-gradient(135deg, hsla(225, 95%, 50%, 1) 10%, hsla(225, 95%, 50%, 0) 80%),
        linear-gradient(225deg, hsla(140, 90%, 50%, 1) 10%, hsla(140, 90%, 50%, 0) 80%),
        linear-gradient(315deg, hsla(35, 95%, 55%, 1) 100%, hsla(35, 95%, 55%, 0) 70%);
    }

    h2 {
      margin-top: 0;
      padding-top: 0.8em;
    }

    /* nav 가 다 감싸고 있음 */
    nav {
      position: relative;
      /* perspective: 600px; */
    }

    /* cool 이 보여야할 내용들을 가리킴 */
    /* a 태그가 메뉴 버튼을 의미 */
    .cool > li > a {
      color: yellow;
      text-decoration: none;
      font-size: 20px;
      background: rgba(0, 0, 0, 0.2);
      padding: 10px 20px;
      display: inline-block;
      margin: 20px;
      border-radius: 5px;
    }

    /* li 을 감싸는 ul 이 자식들을 row 형태로 배치 */
    nav ul {
      list-style: none;
      margin: 0;
      padding: 0;
      display: flex;
      justify-content: center;
    }

    /* nav > ul(.cool) > li(각 메뉴) */
    .cool > li {
      position: relative;
      display: flex;
      justify-content: center;
    }

    /* 메뉴 호버시 보이는 부분 */
    /* position 이 absolute 이므로, relative 인 li 를 부모로 여김 */
    /* a 태그와는 형제 */
    .dropdown {
      opacity: 0;
      position: absolute;
      overflow: hidden;
      padding: 20px;
      top: -20px;
      border-radius: 2px;
      transition: all 0.5s;
      transform: translateY(100px);
      will-change: opacity;
      display: none;
    }

    /* trigger-enter 는 li 에 붙음 */
    .trigger-enter .dropdown {
      display: block;
    }

    /* trigger-enter-active 도 li 에 붙음 */
    .trigger-enter-active .dropdown {
      opacity: 1;
    }

    .dropdownBackground {
      width: 100px;
      height: 100px;
      position: absolute;
      background: #fff;
      border-radius: 4px;
      box-shadow: 0 50px 100px rgba(50, 50, 93, 0.1), 0 15px 35px rgba(50, 50, 93, 0.15), 0 5px 15px rgba(0, 0, 0, 0.1);
      transition: all 0.3s, opacity 0.1s, transform 0.2s;
      transform-origin: 50% 0;
      display: flex;
      justify-content: center;
      opacity: 0;
    }

    /* 드랍다운 박스 */
    .dropdownBackground.open {
      opacity: 1;
    }
    .arrow {
      position: absolute;
      width: 20px;
      height: 20px;
      display: block;
      background: white;
      transform: translateY(-50%) rotate(45deg);
    }

    /* 각 탭별 내용 */
    .bio {
      min-width: 500px;
      display: flex;
      justify-content: center;
      align-items: center;
      line-height: 1.7;
    }
    .bio img {
      float: left;
      margin-right: 20px;
    }

    /* 각 탭별 내용 */
    .courses {
      min-width: 300px;
    }
    .courses li {
      padding: 10px 0;
      display: block;
      border-bottom: 1px solid rgba(0, 0, 0, 0.2);
    }

    .dropdown a {
      text-decoration: none;
      color: #ffc600;
    }

    a.button {
      background: black;
      display: block;
      padding: 10px;
      color: white;
      margin-bottom: 10px;
    }

    /* Matches Twitter, TWITTER, twitter, tWitter, TWiTTeR... */
    .button[href*="twitter"] {
      background: #019fe9;
    }
    .button[href*="facebook"] {
      background: #3b5998;
    }
    .button[href*="courses"] {
      background: #ffc600;
    }
  </style>
  <script>
    // 생성방식은 호버를 감지하고, 흰박스를 만들고, 그 안에 내용을 넣는 과정

    //
    const triggers = document.querySelectorAll(".cool > li");
    const background = document.querySelector(".dropdownBackground");
    const nav = document.querySelector(".top");

    //
    function handleEnter() {
      this.classList.add("trigger-enter");

      // display: block => opacity: 1 을 하는 과정
      // 이 내용은 0.015 에 시작되며, 드랍박스안에 있는 내용을 보여줌
      setTimeout(() => this.classList.contains("trigger-enter") && this.classList.add("trigger-enter-active"), 150);

      // open 붙여야 흰 박스만 보이기 시작
      // 최초에는 드랍박스 내용에 맞지 않은 박스가 나옴
      // 이후 setProperty 과정을 통해 맞추기 시작
      background.classList.add("open");

      const dropdown = this.querySelector(".dropdown");
      const dropdownCoords = dropdown.getBoundingClientRect();
      const navCoords = nav.getBoundingClientRect();

      const coords = {
        height: dropdownCoords.height,
        width: dropdownCoords.width,
        top: dropdownCoords.top - navCoords.top,
        left: dropdownCoords.left - navCoords.left,
      };

      background.style.setProperty("width", `${coords.width}px`);
      background.style.setProperty("height", `${coords.height}px`);
      background.style.setProperty("transform", `translate(${coords.left}px, ${coords.top}px)`);
    }

    function handleLeave() {
      this.classList.remove("trigger-enter", "trigger-enter-active");
      background.classList.remove("open");
    }

    //
    triggers.forEach((trigger) => trigger.addEventListener("mouseenter", handleEnter));
    triggers.forEach((trigger) => trigger.addEventListener("mouseleave", handleLeave));
  </script>
</html>
